/** * jssdk * @since 2017/9/26 */ (function (factory) {
  "use strict";
  if (typeof define === "function" && define.amd) {
    define(factory);
  } else if (typeof module != "undefined" && typeof module.exports != "undefined") {
    module.exports = factory();
  } else if (typeof Package !== "undefined") {
    cst = factory();
  // export for Meteor.js
  } else { /* jshint sub:true */
    window["cst"] = factory();
  }
})(function () {
  var deviceType;
  var MAX_SIZE = "2097152";
  var privateMethods = {
    /** * 鍒ゆ柇璁惧绫诲瀷 */ getDeviceType: function () {
      var deviceType = "H5";
      if (typeof (innoPlus) !== "undefined") {
        deviceType = "IOS";
      } else if (typeof (android) !== "undefined") {
        deviceType = "ANDROID";
      }
      return deviceType;
    },
    addParams: function (path, paramsObj) {
      var params = "";
      if (!paramsObj) {
        return;
      }
      for (index in paramsObj) {
        if (!paramsObj[index]) {
          continue;
        }
        if (!params) {
          params += index + "=" + paramsObj[index];
        } else {
          params += "&" + index + "=" + paramsObj[index];
        }
      }
      if (path.indexOf("?") > -1) {
        path = path + "&" + params;
      } else {
        path = path + "?" + params;
      }
      return path;
    },
    /** * 鎸夐挳鍒嗕韩 */ shareHandle: function (shareInfo) {
      if (deviceType == "IOS") {
        innoPlus.native.showSharePopView(JSON.stringify(shareInfo));
      } else if (deviceType == "ANDROID") {
        android.share(JSON.stringify(shareInfo));
      }
    },
    /** * 鑾峰彇APP鍚嶇О锛堜富瑕佺敤鏉ュ垽鏂競姘戜簯锛� */ getAppName: function () {
      var appName = "";
      if (deviceType == "ANDROID") {
        appName = android.getAppName();
      } else if (deviceType == "IOS") {
        appName = innoPlus.device.appname;
      }
      return appName.toLocaleLowerCase();
    },
    /** * 鎵撳紑app椤甸潰 */ openAppPage: function (pageId, params) {
      var path = privateMethods.addParams(pageId, params) || pageId;
      if (deviceType == "ANDROID") {
        android.openActivityByRoute(path);
      } else if (deviceType == "IOS") {
        innoPlus.native.openWindow(path);
      }
    },
    /** * 鎵撳紑鐧婚檰椤� */ openLogin: function (url) {
      if (deviceType == "ANDROID") {
        android.openLogin(url || "");
      } else if (deviceType == "IOS") {
        innoPlus.native.openLoginPage(true);
      }
    },
    /** * 鎵撳紑鐧诲綍甯﹀洖璋� */ openLoginWithCallback: function (callback) {
      window.openLoginWithCallback = function (data) {
        callback && callback();
      }
      if (deviceType == "ANDROID") {
        android.openLoginWithCallback("openLoginWithCallback");
      } else if (deviceType == "IOS") {
        innoPlus.native.openLoginPage("false", callback);
      }
    },
    /** * 鑾峰彇app鐢ㄦ埛鏍囪瘑 */ getUserId: function () {
      if (deviceType == "IOS") {
        return innoPlus.session.userId;
      } else if (deviceType == "ANDROID") {
        return android.getUserId();
      }
    },
    /** * 鍥為€€ */ back: function () {
      if (deviceType == "IOS") {
        innoPlus.native.back();
      } else if (deviceType == "ANDROID") {
        android.back();
      } else {
      }
    },
    /** * 鍏抽棴webview */ close: function () {
      if (deviceType == "IOS") {
        innoPlus.native.close();
      } else if (deviceType == "ANDROID") {
        android.close();
      }
    },
    /** * 闅愯棌澶撮儴 */ hideHeader: function () {
      if (deviceType == "IOS") {
        innoPlus.native.hideNavbar();
      } else if (deviceType == "ANDROID") {
        android.hideHeader();
      }
    },
    /** * 鑾峰彇token */ getToken: function () {
      if (deviceType == "IOS") {
        return innoPlus.session.token;
      } else if (deviceType == "ANDROID") {
        return android.getToken();
      }
    },
    /** * 鑾峰彇osType */ getOsType: function () {
      var osType = "";
      if (deviceType == "ANDROID") {
        osType = "Android";
      } else if (deviceType == "IOS") {
        osType = "iOS";
      }
      return osType;
    },
    /** * 鑾峰彇token */ getDeviceId: function () {
      if (deviceType == "IOS") {
        return innoPlus.device.uuid;
      } else if (deviceType == "ANDROID") {
        return android.getDeviceId();
      }
    },
    /** * 闅愯棌鍒嗕韩 */ hideShare: function () {
      if (deviceType == "IOS") {
        innoPlus.native.hideShareBtn();
      } else if (deviceType == "ANDROID") {
        android.hideShare();
      }
    },
    /** * 璁剧疆澶撮儴鏍囬 */ setTitle: function (title) {
      if (deviceType == "IOS") {
        innoPlus.native.setTitle(title);
      } else if (deviceType == "ANDROID") {
        android.setTitle(title);
      }
    },
    /** * 鑾峰彇APP鍦板潃 */ getAddress: function (callback) {
      window.getAddr = function (data) {
        typeof data == "string" ? callback(JSON.parse(data)) : callback(data);
      }
      if (deviceType == "IOS") {
        innoPlus.native.selectAddress(callback);
      } else if (deviceType == "ANDROID") {
        android.selectAddress("getAddr");
      }
    },
    /** * 閫夋嫨鏉愭枡 */ selectMaterial: function (callback) {
      window.selectMaterial = function (data) {
        typeof data == "string" ? callback(JSON.parse(data)) : callback(data);
      }
      if (deviceType == "IOS") {
        innoPlus.native.selectMaterial(callback, MAX_SIZE);
      } else if (deviceType == "ANDROID") {
        android.selectMaterial("selectMaterial", MAX_SIZE);
      }
    },
    /** * 鐢熸垚鏉愭枡 */ generateMaterial: function (callback) {
      window.generateMaterial = function (data) {
        typeof data == "string" ? callback(JSON.parse(data)) : callback(data);
      }
      if (deviceType == "IOS") {
        innoPlus.native.generateMaterial(callback, MAX_SIZE);
      } else if (deviceType == "ANDROID") {
        android.generateMaterial("generateMaterial", MAX_SIZE);
      }
    },
    /** * 鐢熸垚鏉愭枡锛堣嚜瀹氫箟鏉愭枡鍚嶏級 */ createMaterial: function (callback) {
      window.createMaterial = function (data) {
        typeof data == "string" ? callback(JSON.parse(data)) : callback(data);
      }
      if (deviceType == "IOS") {
        innoPlus.native.createMaterial(callback, MAX_SIZE);
      } else if (deviceType == "ANDROID") {
        android.createMaterial("createMaterial", MAX_SIZE);
      }
    },
    /** * 澶嶅埗 */ copyToClipboard: function (str, callback) {
      if (deviceType == "IOS") {
        innoPlus.native.paste(str);
        callback && callback();
      } else if (deviceType == "ANDROID") {
        android.copyToClipboard(str);
        callback && callback();
      }
    },
    /** * 鎷ㄦ墦鐢佃瘽 */ openDial: function (phoneNumber) {
      if (deviceType == "IOS") {
        try {
          innoPlus.native.openThirdUrl(function (result) {
            console.log(result);
          }, "tel:" + phoneNumber);
        } catch (e) { //TODO handle the exception
        }
      } else if (deviceType == "ANDROID") {
        android.openDial(phoneNumber);
      }
    },
    /** * 棰勮pdf鏂囦欢 */ previewPDF: function (fileName, fileUrl) {
      if (deviceType == "IOS") {
        var params = {fileName: fileName, fileUrl: fileUrl};
        innoPlus.native.previewPDF(JSON.stringify(params));
      } else if (deviceType == "ANDROID") {
        android.openPDF(fileName, fileUrl);
      }
    },
    /** * 閫夋嫨浠ｇ悊浼佷笟鍒楄〃 */ selectAgentEnterprise: function (callback) {
      window.selectAgentEnterprise = function (data) {
        typeof data == "string" ? callback(JSON.parse(data)) : callback(data);
      };
      if (deviceType == "IOS") {
        innoPlus.native.selectAgentEnterprise(function (data) {
          callback && callback(data);
        })
      } else if (deviceType == "ANDROID") {
        android.selectAgentEnterprise("selectAgentEnterprise");
      }
    },
    /** * 璋冪敤APP浜鸿劯璁よ瘉椤甸潰 */ appFaceAuth: function (callback) {
      if (deviceType == "IOS") {
        innoPlus.native.faceAuth(function (data) {
          callback && callback(data);
        });
      } else if (deviceType == "ANDROID") {
        window.appFaceAuth = function (data) {
          typeof data == "string" ? callback(JSON.parse(data)) : callback(data);
        };
        android.faceAuth("appFaceAuth");
      }
    },
    /** * 璋冪敤app涓汉璁よ瘉 */ appPersonalInfo: function (callback) {
      if (deviceType == "IOS") {
        innoPlus.native.personalInfo(function (data) {
          callback && callback(data);
        });
      } else if (deviceType == "ANDROID") {
        window.appPersonalInfo = function (data) {
          typeof data == "string" ? callback(JSON.parse(data)) : callback(data);
        };
        android.personalInfo("appPersonalInfo");
      }
    },
    /** * 璋冪敤APP瀹屽杽浼佷笟淇℃伅 */ appEnterpriseInfo: function (callback) {
      if (deviceType == "IOS") {
        innoPlus.native.enterpriseInfo(function (data) {
          callback && callback(data);
        });
      } else if (deviceType == "ANDROID") {
        window.appEnterpriseInfo = function (data) {
          typeof data == "string" ? callback(JSON.parse(data)) : callback(data);
        };
        android.enterpriseInfo("appEnterpriseInfo");
      }
    },
    /** * 鑾峰彇APP鍩虹鍙傛暟 */ getBaseParams: function () {
      if (deviceType == "IOS") {
        return innoPlus.baseParam;
      } else if (deviceType == "ANDROID") {
        try {
          var androidObj = android.getBaseParams();
          if (typeof (androidObj) == "string") {
            androidObj = JSON.parse(androidObj);
          }
          return androidObj;
        } catch (e) {
          return undefined;
        }
      }
    },
    /** * 瀵艰埅 * @param {Object} obj */ navigation: function (obj) {
      if (deviceType == "IOS") {
        innoPlus.map.nav(JSON.stringify(obj))
      } else if (deviceType == "ANDROID") {
        android.navigation(JSON.stringify(obj))
      }
    },
    /** * 瀹氫綅鑾峰彇鍦扮悊浣嶇疆淇℃伅 */ appGetLocationInfo: function (callback) {
      if (deviceType == "IOS") {
        innoPlus.native.getLocationInfo(function (data) {
          callback && callback(data);
        });
      } else if (deviceType == "ANDROID") {
        window.appGetLocationInfo = function (data) {
          typeof data == "string" ? callback(JSON.parse(data)) : callback(data);
        };
        try {
          android.getLocationInfo("appGetLocationInfo");
          return true;
        } catch (e) {
          return false;
        }
      }
    },
    /** * 瀹氫綅鑾峰彇鍦扮悊浣嶇疆缁忕含搴� */ getLocationCoordinate: function (callback) {
      if (deviceType == "IOS") {
        innoPlus.native.getLocationCoordinate(function (data) {
          callback && callback(data);
        });
      } else if (deviceType == "ANDROID") {
        window.appGetLocationCoordinate = function (data) {
          typeof data == "string" ? callback(JSON.parse(data)) : callback(data);
        };
        try {
          android.getLocationCoordinate("appGetLocationCoordinate");
          return true;
        } catch (e) {
          return false;
        }
      }
    },
    /** * 璋冪敤APP浼佷笟璁よ瘉 */ appEnterpeiseAuth: function (callback) {
      if (deviceType == "IOS") {
        innoPlus.native.enterpeiseAuth(function (data) {
          callback && callback(data);
        });
      } else if (deviceType == "ANDROID") {
        window.appEnterpriseAuth = function (data) {
          typeof data == "string" ? callback(JSON.parse(data)) : callback(data);
        };
        android.enterpeiseAuth("appEnterpriseAuth");
      }
    },
    /** * 閫氱煡 * @param {*} notificationName */ notification: function (notificationName = "cstoonH5PaySuccess") {
      if (deviceType == "IOS") {
        innoPlus.native.notification(JSON.stringify({notificationName}));
      } else if (deviceType == "ANDROID") {
        android.notification(JSON.stringify({notificationName}));
      }
    },
    /** * 璋冪敤APP鎵弿浜岀淮鐮侊紙寮傛杩斿洖鎵爜淇℃伅锛� * @param {Object} callback */ openScanningWithBlock: function (callback) {
      try {
        if (deviceType == "IOS") {
          innoPlus.native.openScanningWithBlock(function (data) {
            callback && callback(data ? data.content : '');
          });
        } else if (deviceType == "ANDROID") {
          window.openScanningWithBlock = function (data) {
            callback(data);
          };
          android.openScanningWithBlock("openScanningWithBlock");
        }
        return true;
      } catch (e) {
        return false;
      }
    },
    /** * 璋冭捣寰俊鏀粯 * @param {Object} jsonStr * @param {Object} callback */ wechatPay: function (jsonStr, callback) {
      if (deviceType == 'IOS') {
        innoPlus.native.wechatPay(jsonStr, function (data) {
          callback && callback(data)
        })
      } else if (deviceType == 'ANDROID') {
        android.wechatPay(jsonStr, function (data) {
          callback && callback(data)
        })
      }
    },
    /** * 璋冭捣寰俊灏忕▼搴忔敮浠� * @param {String} userName 璐﹀彿鍘熷ID * @param {String} path 鍘熷璺緞 * @param {Int} miniProgramType 锛堝拰寰俊鎻愪緵鐨勪竴鑷达級0锛氭寮忕増 1锛氬紑鍙戠増 2锛氫綋楠岀増 */ launchMiniProgram: function (userName, path, miniptogramType) {
      if (deviceType == 'IOS') {
        let jsonStr = JSON.stringify({
          userName: userName,
          path: encodeURIComponent(path),
          miniProgramType: miniptogramType
        });
        innoPlus.native.launchMiniProgram(jsonStr)
      } else if (deviceType == 'ANDROID') {
        this.openAppPage("ACComponentShare://method/launchMiniProgram?appid=&userName=" + userName + "&path=" + encodeURIComponent(path) + "&miniptogramType=" + miniptogramType);
      }
    },
    /** * 璋冭捣寰俊灏忕▼搴忔敮浠� * @param {String} userName 璐﹀彿鍘熷ID * @param {String} path 鍘熷璺緞 * @param {Int} miniptogramType 锛堝拰寰俊鎻愪緵鐨勪竴鑷达級0锛氭寮忕増 1锛氬紑鍙戠増 2锛氫綋楠岀増 * @param {Object} callback */ launchMiniProgramWithBlock: function (userName, path, miniptogramType, callback) {
      if (deviceType == 'IOS') {
        let jsonStr = JSON.stringify({userName: userName, path: path, miniptogramType: miniptogramType});
        innoPlus.native.launchMiniProgramWithBlock(jsonStr, function (data) {
          callback && callback(data)
        })
      } else if (deviceType == 'ANDROID') {
        android.launchMiniProgramWithBlock(userName, path, miniptogramType, function (data) {
          callback && callback(data)
        })
      }
    },
    /** * 璋冭捣閫氳仈鏀粯 */ openAllinPay: function (jsonObj, callback) {
      let jsonStr = JSON.stringify(jsonObj);
      if (deviceType == 'IOS') {
        innoPlus.native.openAllinPay(jsonStr, function (result) {
          callback && callback(result)
        });
      } else if (deviceType == 'ANDROID') {
        window.openAllinPay = function (data) {
          callback && callback(data);
        };
        android.openAllinPay(jsonStr, "openAllinPay");
      }
    },
    /** * 鍒ゆ柇鏄惁鏄湪鍩庡競閫歛pp鍐� */ isCstoon: function () {
      var userAgent = navigator.userAgent.toLowerCase();
      return userAgent.indexOf("innoapp") > -1;
    }
  };
  window.onload = function () {
    deviceType = privateMethods.getDeviceType();
  }
  return {
    /** * 鎵撳紑app椤甸潰 */ openAppPage: privateMethods.openAppPage,
    /** * 鑾峰彇璁惧绫诲瀷 */ getDeviceType: privateMethods.getDeviceType,
    /** * 鍥為€€ */ back: privateMethods.back,
    /** * 鍏抽棴 */ close: privateMethods.close,
    /** * 闅愯棌澶撮儴 */ hideHeader: privateMethods.hideHeader,
    /** * 鑾峰彇app鐢ㄦ埛琛ㄧず */ getUserId: privateMethods.getUserId,
    /** * 鑾峰彇getToken */ getToken: privateMethods.getToken,
    /** * 鑾峰彇osType */ getOsType: privateMethods.getOsType,
    /** * 鑾峰彇app璁惧鏍囪瘑 */ getDeviceId: privateMethods.getDeviceId,
    /** * 璁剧疆app澶撮儴 */ setTitle: privateMethods.setTitle,
    /** * 闅愯棌app鍒嗕韩鎸夐挳 */ hideShare: privateMethods.hideShare,
    /** * 鎵撳紑鐧诲綍椤� */ openLogin: privateMethods.openLogin,
    /** * 鎵撳紑鐧诲綍椤靛甫鍥炶皟 */ openLoginWithCallback: privateMethods.openLoginWithCallback,
    /** * 鑾峰彇娴忚鍣ㄦ墍灞炵郴缁� */ getBrowerType: privateMethods.getBrowerType,
    /** * 鑾峰彇鑱旂郴鍦板潃 */ getAddress: privateMethods.getAddress,
    /** * 閫夋嫨鏉愭枡 */ selectMaterial: privateMethods.selectMaterial,
    /** * 鐢熸垚鏉愭枡 */ generateMaterial: privateMethods.generateMaterial,
    /** * 鐢熸垚鏉愭枡锛堣嚜瀹氫箟鏉愭枡鍚嶏級 */ createMaterial: privateMethods.createMaterial,
    /** * 澶嶅埗 */ copyToClipboard: privateMethods.copyToClipboard,
    /** * 鑾峰彇APP鍩虹鍙傛暟 */ getBaseParams: privateMethods.getBaseParams,
    /** * 鎷ㄦ墦鐢佃瘽 */ openDial: privateMethods.openDial,
    /** * 棰勮pdf鏂囦欢 */ previewPDF: privateMethods.previewPDF,
    /** * 閫夋嫨浠ｇ悊浼佷笟鍒楄〃 */ selectAgentEnterprise: privateMethods.selectAgentEnterprise,
    /** * app浜鸿劯璁よ瘉 */ appFaceAuth: privateMethods.appFaceAuth,
    /** * app涓汉璁よ瘉 */ appPersonalInfo: privateMethods.appPersonalInfo,
    /** * app瀹屽杽浼佷笟淇℃伅 */ appEnterpriseInfo: privateMethods.appEnterpriseInfo,
    /** * 鎵嬪姩鍒嗕韩 */ shareHandle: privateMethods.shareHandle,
    /** * 瀵艰埅 */ navigation: privateMethods.navigation,
    /** * 瀹氫綅鑾峰彇鍦扮悊浣嶇疆淇℃伅 */ appGetLocationInfo: privateMethods.appGetLocationInfo,
    /** * 瀹氫綅鑾峰彇鍦扮悊浣嶇疆缁忕含搴� */ getLocationCoordinate: privateMethods.getLocationCoordinate,
    /** * 璺宠浆浼佷笟璁よ瘉 */ appEnterpeiseAuth: privateMethods.appEnterpeiseAuth,
    /** * 閫氱煡 */ notification: privateMethods.notification,
    /** * 鎵竴鎵� */ openScanningWithBlock: privateMethods.openScanningWithBlock,
    /** * 璋冭捣寰俊鏀粯 */ wechatPay: privateMethods.wechatPay,
    /** * 璋冭捣寰俊鏀粯 */ launchMiniProgram: privateMethods.launchMiniProgram,
    /** * 璋冭捣灏忕▼搴忔敮浠� */ launchMiniProgramWithBlock: privateMethods.launchMiniProgramWithBlock,
    /** * 鍒ゆ柇鏄惁鍦ㄥ煄甯傞€氬唴 */ isCstoon: privateMethods.isCstoon,
    /** * 璋冭捣閫氳仈鏀粯 */ openAllinPay: privateMethods.openAllinPay
  }
})
